var FlomoViewControllerW = JSB.defineClass(
  "FlomoViewControllerW : UIViewController <UIWebViewDelegate>",
  {
    viewDidLoad: function () {
      self.text = "";
      var webFrame = self.view.bounds;

      self.webView = new UIWebView(webFrame);

      self.webView.backgroundColor = UIColor.whiteColor();
      self.webView.scalesPageToFit = true;
      self.webView.autoresizingMask = (1 << 1) | (1 << 4);
      self.webView.delegate = self;
      self.webView.scrollView.delegate = self;
      self.webView.layer.cornerRadius = 15;
      self.webView.layer.masksToBounds = true;
      self.view.layer.shadowOffset = {
        width: 0,
        height: 0,
      };
      self.view.layer.shadowRadius = 10;
      self.view.layer.shadowOpacity = 0.5;
      self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
      self.view.addSubview(self.webView);
      self.webView.loadRequest(
        NSURLRequest.requestWithURL(
          NSURL.URLWithString("https://flomoapp.com/login/")
        )
      );
    },
    viewWillAppear: function (animated) {
      self.webView.delegate = self;
    },
    viewWillDisappear: function (animated) {
      self.webView.stopLoading();
      self.webView.delegate = null;

      UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    },
    textFieldShouldReturn: function (textField) {
      textField.resignFirstResponder();
      self.webView.loadRequest(
        NSURLRequest.requestWithURL(NSURL.URLWithString(textField.text))
      );

      return true;
    },
    webViewDidStartLoad: function (webView) {
      UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
    },
    webViewDidFinishLoad: function (webView) {
      webView.evaluateJavaScript(
        "function setContent(val){document.querySelector('.ProseMirror').append(val)}"
      );

      UIApplication.sharedApplication().networkActivityIndicatorVisible = false;

      // Application.sharedInstance().alert(self.text);
    },
    webViewDidFailLoadWithError: function (webView, error) {
      UIApplication.sharedApplication().networkActivityIndicatorVisible = false;

      var errorString =
        "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\"><html><head><meta http-equiv='Content-Type' content='text/html;charset=utf-8'><title></title></head><body><div style='width: 100%%; text-align: center; font-size: 36pt; color: red;'>An error occurred:<br>%@</div></body></html>";
      errorString = errorString.replace("%@", error.localizedDescription);

      self.webView.loadHTMLStringBaseURL(errorString, null);
    },
    webViewShouldStartLoadWithRequestNavigationType: function (
      webView,
      request,
      type
    ) {
      JSB.log("MNLOG %@", request);
      return true;
    },
  }
);

FlomoViewControllerW.prototype.saveText = function (text) {
  if (!this.webView || !this.webView.window) return;
  this.text = text;
  var scp = "setContent('"+text.replace(/\\/g,"\\\\").replace(/'/g,"\\'").replace(/\n/g,"\\n")+"');";
  this.webView.evaluateJavaScript(scp)
};
